diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-header.cc ns-3.40/src/internet/model/tcp-header.cc
--- ns-3.39/src/internet/model/tcp-header.cc	2023-07-05 14:23:47.857427600 -0700
+++ ns-3.40/src/internet/model/tcp-header.cc	2023-09-27 13:30:37.662839200 -0700
@@ -35,25 +35,6 @@
 
 NS_OBJECT_ENSURE_REGISTERED(TcpHeader);
 
-TcpHeader::TcpHeader()
-    : m_sourcePort(0),
-      m_destinationPort(0),
-      m_sequenceNumber(0),
-      m_ackNumber(0),
-      m_length(5),
-      m_flags(0),
-      m_windowSize(0xffff),
-      m_urgentPointer(0),
-      m_calcChecksum(false),
-      m_goodChecksum(true),
-      m_optionsLen(0)
-{
-}
-
-TcpHeader::~TcpHeader()
-{
-}
-
 std::string
 TcpHeader::FlagsToString(uint8_t flags, const std::string& delimiter)
 {
@@ -63,7 +44,7 @@
     {
         if (flags & (1 << i))
         {
-            if (flagsDescription.length() > 0)
+            if (!flagsDescription.empty())
             {
                 flagsDescription += delimiter;
             }
@@ -286,9 +267,7 @@
 
     os << " Seq=" << m_sequenceNumber << " Ack=" << m_ackNumber << " Win=" << m_windowSize;
 
-    TcpOptionList::const_iterator op;
-
-    for (op = m_options.begin(); op != m_options.end(); ++op)
+    for (auto op = m_options.begin(); op != m_options.end(); ++op)
     {
         os << " " << (*op)->GetInstanceTypeId().GetName() << "(";
         (*op)->Print(os);
@@ -319,8 +298,8 @@
     // This implementation does not presently try to align options on word
     // boundaries using NOP options
     uint32_t optionLen = 0;
-    TcpOptionList::const_iterator op;
-    for (op = m_options.begin(); op != m_options.end(); ++op)
+
+    for (auto op = m_options.begin(); op != m_options.end(); ++op)
     {
         optionLen += (*op)->GetSerializedSize();
         (*op)->Serialize(i);
@@ -436,9 +415,8 @@
 TcpHeader::CalculateHeaderLength() const
 {
     uint32_t len = 20;
-    TcpOptionList::const_iterator i;
 
-    for (i = m_options.begin(); i != m_options.end(); ++i)
+    for (auto i = m_options.begin(); i != m_options.end(); ++i)
     {
         len += (*i)->GetSerializedSize();
     }
@@ -485,9 +463,7 @@
 Ptr<const TcpOption>
 TcpHeader::GetOption(uint8_t kind) const
 {
-    TcpOptionList::const_iterator i;
-
-    for (i = m_options.begin(); i != m_options.end(); ++i)
+    for (auto i = m_options.begin(); i != m_options.end(); ++i)
     {
         if ((*i)->GetKind() == kind)
         {
@@ -501,9 +477,7 @@
 bool
 TcpHeader::HasOption(uint8_t kind) const
 {
-    TcpOptionList::const_iterator i;
-
-    for (i = m_options.begin(); i != m_options.end(); ++i)
+    for (auto i = m_options.begin(); i != m_options.end(); ++i)
     {
         if ((*i)->GetKind() == kind)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-header.h ns-3.40/src/internet/model/tcp-header.h
--- ns-3.39/src/internet/model/tcp-header.h	2023-07-05 14:23:47.857427600 -0700
+++ ns-3.40/src/internet/model/tcp-header.h	2023-09-27 13:30:37.662839200 -0700
@@ -20,13 +20,14 @@
 #ifndef TCP_HEADER_H
 #define TCP_HEADER_H
 
+#include "tcp-option.h"
+#include "tcp-socket-factory.h"
+
 #include "ns3/buffer.h"
 #include "ns3/header.h"
 #include "ns3/ipv4-address.h"
 #include "ns3/ipv6-address.h"
 #include "ns3/sequence-number.h"
-#include "ns3/tcp-option.h"
-#include "ns3/tcp-socket-factory.h"
 
 #include <stdint.h>
 
@@ -45,9 +46,6 @@
 class TcpHeader : public Header
 {
   public:
-    TcpHeader();
-    ~TcpHeader() override;
-
     typedef std::list<Ptr<const TcpOption>> TcpOptionList; //!< List of TcpOption
 
     /**
@@ -331,25 +329,25 @@
      */
     uint8_t CalculateHeaderLength() const;
 
-    uint16_t m_sourcePort;             //!< Source port
-    uint16_t m_destinationPort;        //!< Destination port
-    SequenceNumber32 m_sequenceNumber; //!< Sequence number
-    SequenceNumber32 m_ackNumber;      //!< ACK number
-    uint8_t m_length;                  //!< Length (really a uint4_t) in words.
-    uint8_t m_flags;                   //!< Flags (really a uint6_t)
-    uint16_t m_windowSize;             //!< Window size
-    uint16_t m_urgentPointer;          //!< Urgent pointer
+    uint16_t m_sourcePort{0};             //!< Source port
+    uint16_t m_destinationPort{0};        //!< Destination port
+    SequenceNumber32 m_sequenceNumber{0}; //!< Sequence number
+    SequenceNumber32 m_ackNumber{0};      //!< ACK number
+    uint8_t m_length{5};                  //!< Length (really a uint4_t) in words.
+    uint8_t m_flags{0};                   //!< Flags (really a uint6_t)
+    uint16_t m_windowSize{0xffff};        //!< Window size
+    uint16_t m_urgentPointer{0};          //!< Urgent pointer
 
     Address m_source;      //!< Source IP address
     Address m_destination; //!< Destination IP address
-    uint8_t m_protocol;    //!< Protocol number
+    uint8_t m_protocol{6}; //!< Protocol number
 
-    bool m_calcChecksum; //!< Flag to calculate checksum
-    bool m_goodChecksum; //!< Flag to indicate that checksum is correct
+    bool m_calcChecksum{false}; //!< Flag to calculate checksum
+    bool m_goodChecksum{true};  //!< Flag to indicate that checksum is correct
 
     static const uint8_t m_maxOptionsLen = 40; //!< Maximum options length
     TcpOptionList m_options;                   //!< TcpOption present in the header
-    uint8_t m_optionsLen;                      //!< Tcp options length.
+    uint8_t m_optionsLen{0};                   //!< Tcp options length.
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-htcp.cc ns-3.40/src/internet/model/tcp-htcp.cc
--- ns-3.39/src/internet/model/tcp-htcp.cc	2023-07-05 14:23:47.857427600 -0700
+++ ns-3.40/src/internet/model/tcp-htcp.cc	2023-09-27 13:30:37.662839200 -0700
@@ -182,7 +182,7 @@
     UpdateAlpha();
 
     uint32_t segWin = 2 * tcb->m_segmentSize;
-    uint32_t bFlight = static_cast<uint32_t>(bytesInFlight * m_beta);
+    auto bFlight = static_cast<uint32_t>(bytesInFlight * m_beta);
     uint32_t ssThresh = std::max(segWin, bFlight);
     m_minRtt = Time::Max();
     m_maxRtt = Time::Min();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-hybla.cc ns-3.40/src/internet/model/tcp-hybla.cc
--- ns-3.39/src/internet/model/tcp-hybla.cc	2023-07-05 14:23:47.857427600 -0700
+++ ns-3.40/src/internet/model/tcp-hybla.cc	2023-09-27 13:30:37.662839200 -0700
@@ -106,7 +106,7 @@
          */
 
         double increment = std::pow(2, m_rho) - 1.0;
-        uint32_t incr = static_cast<uint32_t>(increment * tcb->m_segmentSize);
+        auto incr = static_cast<uint32_t>(increment * tcb->m_segmentSize);
         NS_LOG_INFO("Slow start: inc=" << increment);
 
         tcb->m_cWnd = std::min(tcb->m_cWnd + incr, tcb->m_ssThresh);
@@ -145,7 +145,7 @@
     if (m_cWndCnt >= 1.0)
     {
         // double to int truncates every time.
-        uint32_t inc = static_cast<uint32_t>(m_cWndCnt);
+        auto inc = static_cast<uint32_t>(m_cWndCnt);
         m_cWndCnt -= inc;
 
         NS_ASSERT(m_cWndCnt >= 0.0);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-ledbat.cc ns-3.40/src/internet/model/tcp-ledbat.cc
--- ns-3.39/src/internet/model/tcp-ledbat.cc	2023-07-05 14:23:47.857427600 -0700
+++ ns-3.40/src/internet/model/tcp-ledbat.cc	2023-09-27 13:30:37.662839200 -0700
@@ -288,7 +288,7 @@
     }
     else
     {
-        uint32_t last = static_cast<uint32_t>(m_baseHistory.buffer.size() - 1);
+        auto last = static_cast<uint32_t>(m_baseHistory.buffer.size() - 1);
         if (owd < m_baseHistory.buffer[last])
         {
             m_baseHistory.buffer[last] = owd;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-linux-reno.h ns-3.40/src/internet/model/tcp-linux-reno.h
--- ns-3.39/src/internet/model/tcp-linux-reno.h	2023-07-05 14:23:47.857427600 -0700
+++ ns-3.40/src/internet/model/tcp-linux-reno.h	2023-09-27 13:30:37.662839200 -0700
@@ -22,8 +22,8 @@
 #ifndef TCPLINUXRENO_H
 #define TCPLINUXRENO_H
 
-#include "ns3/tcp-congestion-ops.h"
-#include "ns3/tcp-socket-state.h"
+#include "tcp-congestion-ops.h"
+#include "tcp-socket-state.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-option-rfc793.h ns-3.40/src/internet/model/tcp-option-rfc793.h
--- ns-3.39/src/internet/model/tcp-option-rfc793.h	2023-07-05 14:23:47.857427600 -0700
+++ ns-3.40/src/internet/model/tcp-option-rfc793.h	2023-09-27 13:30:37.662839200 -0700
@@ -19,7 +19,7 @@
 #ifndef TCPOPTIONRFC793_H
 #define TCPOPTIONRFC793_H
 
-#include "ns3/tcp-option.h"
+#include "tcp-option.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-option-sack.cc ns-3.40/src/internet/model/tcp-option-sack.cc
--- ns-3.39/src/internet/model/tcp-option-sack.cc	2023-07-05 14:23:47.857427600 -0700
+++ ns-3.40/src/internet/model/tcp-option-sack.cc	2023-09-27 13:30:37.662839200 -0700
@@ -62,7 +62,7 @@
 TcpOptionSack::Print(std::ostream& os) const
 {
     os << "blocks: " << GetNumSackBlocks() << ",";
-    for (SackList::const_iterator it = m_sackList.begin(); it != m_sackList.end(); ++it)
+    for (auto it = m_sackList.begin(); it != m_sackList.end(); ++it)
     {
         os << "[" << it->first << "," << it->second << "]";
     }
@@ -82,10 +82,10 @@
     NS_LOG_FUNCTION(this);
     Buffer::Iterator i = start;
     i.WriteU8(GetKind()); // Kind
-    uint8_t length = static_cast<uint8_t>(GetNumSackBlocks() * 8 + 2);
+    auto length = static_cast<uint8_t>(GetNumSackBlocks() * 8 + 2);
     i.WriteU8(length); // Length
 
-    for (SackList::const_iterator it = m_sackList.begin(); it != m_sackList.end(); ++it)
+    for (auto it = m_sackList.begin(); it != m_sackList.end(); ++it)
     {
         SequenceNumber32 leftEdge = it->first;
         SequenceNumber32 rightEdge = it->second;
@@ -112,8 +112,8 @@
     uint8_t sackCount = (size - 2) / 8;
     while (sackCount)
     {
-        SequenceNumber32 leftEdge = SequenceNumber32(i.ReadNtohU32());
-        SequenceNumber32 rightEdge = SequenceNumber32(i.ReadNtohU32());
+        SequenceNumber32 leftEdge(i.ReadNtohU32());
+        SequenceNumber32 rightEdge(i.ReadNtohU32());
         SackBlock s(leftEdge, rightEdge);
         AddSackBlock(s);
         sackCount--;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-option-sack.h ns-3.40/src/internet/model/tcp-option-sack.h
--- ns-3.39/src/internet/model/tcp-option-sack.h	2023-07-05 14:23:47.857427600 -0700
+++ ns-3.40/src/internet/model/tcp-option-sack.h	2023-09-27 13:30:37.662839200 -0700
@@ -25,8 +25,9 @@
 #ifndef TCP_OPTION_SACK_H
 #define TCP_OPTION_SACK_H
 
+#include "tcp-option.h"
+
 #include "ns3/sequence-number.h"
-#include "ns3/tcp-option.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-option-sack-permitted.h ns-3.40/src/internet/model/tcp-option-sack-permitted.h
--- ns-3.39/src/internet/model/tcp-option-sack-permitted.h	2023-07-05 14:23:47.857427600 -0700
+++ ns-3.40/src/internet/model/tcp-option-sack-permitted.h	2023-09-27 13:30:37.662839200 -0700
@@ -25,7 +25,7 @@
 #ifndef TCP_OPTION_SACK_PERMITTED_H
 #define TCP_OPTION_SACK_PERMITTED_H
 
-#include "ns3/tcp-option.h"
+#include "tcp-option.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-option-ts.h ns-3.40/src/internet/model/tcp-option-ts.h
--- ns-3.39/src/internet/model/tcp-option-ts.h	2023-07-05 14:23:47.857427600 -0700
+++ ns-3.40/src/internet/model/tcp-option-ts.h	2023-09-27 13:30:37.662839200 -0700
@@ -20,7 +20,8 @@
 #ifndef TCP_OPTION_TS_H
 #define TCP_OPTION_TS_H
 
-#include "ns3/tcp-option.h"
+#include "tcp-option.h"
+
 #include "ns3/timer.h"
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-option-winscale.h ns-3.40/src/internet/model/tcp-option-winscale.h
--- ns-3.39/src/internet/model/tcp-option-winscale.h	2023-07-05 14:23:47.857427600 -0700
+++ ns-3.40/src/internet/model/tcp-option-winscale.h	2023-09-27 13:30:37.662839200 -0700
@@ -21,7 +21,7 @@
 #ifndef TCP_OPTION_WINSCALE_H
 #define TCP_OPTION_WINSCALE_H
 
-#include "ns3/tcp-option.h"
+#include "tcp-option.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-prr-recovery.h ns-3.40/src/internet/model/tcp-prr-recovery.h
--- ns-3.39/src/internet/model/tcp-prr-recovery.h	2023-07-05 14:23:47.857427600 -0700
+++ ns-3.40/src/internet/model/tcp-prr-recovery.h	2023-09-27 13:30:37.662839200 -0700
@@ -22,7 +22,7 @@
 #ifndef TCP_PRR_RECOVERY_H
 #define TCP_PRR_RECOVERY_H
 
-#include "ns3/tcp-recovery-ops.h"
+#include "tcp-recovery-ops.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-rate-ops.h ns-3.40/src/internet/model/tcp-rate-ops.h
--- ns-3.39/src/internet/model/tcp-rate-ops.h	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/tcp-rate-ops.h	2023-09-27 13:30:37.662839200 -0700
@@ -18,9 +18,10 @@
 #ifndef TCP_RATE_OPS_H
 #define TCP_RATE_OPS_H
 
+#include "tcp-tx-item.h"
+
 #include "ns3/data-rate.h"
 #include "ns3/object.h"
-#include "ns3/tcp-tx-item.h"
 #include "ns3/traced-callback.h"
 #include "ns3/traced-value.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-rx-buffer.cc ns-3.40/src/internet/model/tcp-rx-buffer.cc
--- ns-3.39/src/internet/model/tcp-rx-buffer.cc	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/tcp-rx-buffer.cc	2023-09-27 13:30:37.662839200 -0700
@@ -172,7 +172,7 @@
         }
     }
     // Remove overlapped bytes from packet
-    BufIterator i = m_data.begin();
+    auto i = m_data.begin();
     while (i != m_data.end() && i->first <= tailSeq)
     {
         SequenceNumber32 lastByteSeq = i->first + SequenceNumber32(i->second->GetSize());
@@ -204,7 +204,7 @@
     else
     {
         uint32_t start = static_cast<uint32_t>(headSeq - tcph.GetSequenceNumber());
-        uint32_t length = static_cast<uint32_t>(tailSeq - headSeq);
+        auto length = static_cast<uint32_t>(tailSeq - headSeq);
         p = p->CreateFragment(start, length);
         NS_ASSERT(length == p->GetSize());
     }
@@ -292,7 +292,7 @@
     // We have inserted the block at the beginning of the list. Now, we should
     // check if any existing blocks overlap with that.
     bool updated = false;
-    TcpOptionSack::SackList::iterator it = m_sackList.begin();
+    auto it = m_sackList.begin();
     TcpOptionSack::SackBlock begin = *it;
     TcpOptionSack::SackBlock merged;
     ++it;
@@ -353,8 +353,7 @@
 {
     NS_LOG_FUNCTION(this << seq);
 
-    TcpOptionSack::SackList::iterator it;
-    for (it = m_sackList.begin(); it != m_sackList.end();)
+    for (auto it = m_sackList.begin(); it != m_sackList.end();)
     {
         TcpOptionSack::SackBlock block = *it;
         NS_ASSERT(block.first < block.second);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-rx-buffer.h ns-3.40/src/internet/model/tcp-rx-buffer.h
--- ns-3.39/src/internet/model/tcp-rx-buffer.h	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/tcp-rx-buffer.h	2023-09-27 13:30:37.662839200 -0700
@@ -20,10 +20,11 @@
 #ifndef TCP_RX_BUFFER_H
 #define TCP_RX_BUFFER_H
 
+#include "tcp-header.h"
+#include "tcp-option-sack.h"
+
 #include "ns3/ptr.h"
 #include "ns3/sequence-number.h"
-#include "ns3/tcp-header.h"
-#include "ns3/tcp-option-sack.h"
 #include "ns3/trace-source-accessor.h"
 #include "ns3/traced-value.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-socket-base.cc ns-3.40/src/internet/model/tcp-socket-base.cc
--- ns-3.39/src/internet/model/tcp-socket-base.cc	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/tcp-socket-base.cc	2023-09-27 13:30:37.662839200 -0700
@@ -1851,7 +1851,7 @@
 
     m_txBuffer->DiscardUpTo(ackNumber, MakeCallback(&TcpRateOps::SkbDelivered, m_rateOps));
 
-    uint32_t currentDelivered =
+    auto currentDelivered =
         static_cast<uint32_t>(m_rateOps->GetConnectionRate().m_delivered - previousDelivered);
     m_tcb->m_lastAckedSackedBytes = currentDelivered;
 
@@ -3272,7 +3272,7 @@
     }
     else
     { // This is a retransmit, find in list and mark as re-tx
-        for (std::deque<RttHistory>::iterator i = m_history.begin(); i != m_history.end(); ++i)
+        for (auto i = m_history.begin(); i != m_history.end(); ++i)
         {
             if ((seq >= i->seq) && (seq < (i->seq + SequenceNumber32(i->count))))
             { // Found it
@@ -3291,13 +3291,13 @@
     NS_LOG_FUNCTION(this << withAck);
     if (m_txBuffer->Size() == 0)
     {
-        return false; // Nothing to send
+        return 0; // Nothing to send
     }
     if (m_endPoint == nullptr && m_endPoint6 == nullptr)
     {
         NS_LOG_INFO(
             "TcpSocketBase::SendPendingData: No endpoint; m_shutdownSend=" << m_shutdownSend);
-        return false; // Is this the right way to handle this condition?
+        return 0; // Is this the right way to handle this condition?
     }
 
     uint32_t nPacketsSent = 0;
@@ -3370,7 +3370,7 @@
 
             uint32_t s = std::min(availableWindow, m_tcb->m_segmentSize);
             // NextSeg () may have further constrained the segment size
-            uint32_t maxSizeToSend = static_cast<uint32_t>(nextHigh - next);
+            auto maxSizeToSend = static_cast<uint32_t>(nextHigh - next);
             s = std::min(s, maxSizeToSend);
 
             // (C.2) If any of the data octets sent in (C.1) are below HighData,
@@ -4317,8 +4317,8 @@
 
     // Append the allowed number of SACK blocks
     Ptr<TcpOptionSack> option = CreateObject<TcpOptionSack>();
-    TcpOptionSack::SackList::iterator i;
-    for (i = sackList.begin(); allowedSackBlocks > 0 && i != sackList.end(); ++i)
+
+    for (auto i = sackList.begin(); allowedSackBlocks > 0 && i != sackList.end(); ++i)
     {
         option->AddSackBlock(*i);
         allowedSackBlocks--;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-socket-base.h ns-3.40/src/internet/model/tcp-socket-base.h
--- ns-3.39/src/internet/model/tcp-socket-base.h	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/tcp-socket-base.h	2023-09-27 13:30:37.662839200 -0700
@@ -20,13 +20,14 @@
 #ifndef TCP_SOCKET_BASE_H
 #define TCP_SOCKET_BASE_H
 
+#include "ipv4-header.h"
+#include "ipv6-header.h"
+#include "tcp-socket-state.h"
+#include "tcp-socket.h"
+
 #include "ns3/data-rate.h"
-#include "ns3/ipv4-header.h"
-#include "ns3/ipv6-header.h"
 #include "ns3/node.h"
 #include "ns3/sequence-number.h"
-#include "ns3/tcp-socket-state.h"
-#include "ns3/tcp-socket.h"
 #include "ns3/timer.h"
 #include "ns3/traced-value.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-socket-factory-impl.h ns-3.40/src/internet/model/tcp-socket-factory-impl.h
--- ns-3.39/src/internet/model/tcp-socket-factory-impl.h	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/tcp-socket-factory-impl.h	2023-09-27 13:30:37.662839200 -0700
@@ -19,8 +19,9 @@
 #ifndef TCP_SOCKET_FACTORY_IMPL_H
 #define TCP_SOCKET_FACTORY_IMPL_H
 
+#include "tcp-socket-factory.h"
+
 #include "ns3/ptr.h"
-#include "ns3/tcp-socket-factory.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-tx-buffer.cc ns-3.40/src/internet/model/tcp-tx-buffer.cc
--- ns-3.39/src/internet/model/tcp-tx-buffer.cc	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/tcp-tx-buffer.cc	2023-09-27 13:30:37.662839200 -0700
@@ -68,16 +68,14 @@
 
 TcpTxBuffer::~TcpTxBuffer()
 {
-    PacketList::iterator it;
-
-    for (it = m_sentList.begin(); it != m_sentList.end(); ++it)
+    for (auto it = m_sentList.begin(); it != m_sentList.end(); ++it)
     {
         TcpTxItem* item = *it;
         m_sentSize -= item->m_packet->GetSize();
         delete item;
     }
 
-    for (it = m_appList.begin(); it != m_appList.end(); ++it)
+    for (auto it = m_appList.begin(); it != m_appList.end(); ++it)
     {
         TcpTxItem* item = *it;
         m_size -= item->m_packet->GetSize();
@@ -189,7 +187,7 @@
     {
         if (p->GetSize() > 0)
         {
-            TcpTxItem* item = new TcpTxItem();
+            auto item = new TcpTxItem();
             item->m_packet = p->Copy();
             m_appList.insert(m_appList.end(), item);
             m_size += p->GetSize();
@@ -437,7 +435,7 @@
     Ptr<Packet> currentPacket = nullptr;
     TcpTxItem* currentItem = nullptr;
     TcpTxItem* outItem = nullptr;
-    PacketList::iterator it = list.begin();
+    auto it = list.begin();
     SequenceNumber32 beginOfCurrentPacket = listStartFrom;
 
     while (it != list.end())
@@ -469,7 +467,7 @@
                 NS_LOG_INFO("we are at " << beginOfCurrentPacket << " searching for " << seq
                                          << " and now we recurse because packet ends at "
                                          << beginOfCurrentPacket + currentPacket->GetSize());
-                TcpTxItem* firstPart = new TcpTxItem();
+                auto firstPart = new TcpTxItem();
                 SplitItems(firstPart, currentItem, seq - beginOfCurrentPacket);
 
                 // insert firstPart before currentItem
@@ -535,7 +533,7 @@
             {
                 // the end is inside the current packet, but it isn't exactly
                 // the packet end. Just fragment, fix the list, and return.
-                TcpTxItem* firstPart = new TcpTxItem();
+                auto firstPart = new TcpTxItem();
                 SplitItems(firstPart, currentItem, numBytes);
 
                 // insert firstPart before currentItem
@@ -603,14 +601,14 @@
     {
         if (t1->m_retrans)
         {
-            TcpTxBuffer* self = const_cast<TcpTxBuffer*>(this);
+            auto self = const_cast<TcpTxBuffer*>(this);
             self->m_retrans -= t1->m_packet->GetSize();
             t1->m_retrans = false;
         }
         else
         {
             NS_ASSERT(t2->m_retrans);
-            TcpTxBuffer* self = const_cast<TcpTxBuffer*>(this);
+            auto self = const_cast<TcpTxBuffer*>(this);
             self->m_retrans -= t2->m_packet->GetSize();
             t2->m_retrans = false;
         }
@@ -681,7 +679,7 @@
     // Scan the buffer and discard packets
     uint32_t offset = seq - m_firstByteSeq.Get(); // Number of bytes to remove
     uint32_t pktSize;
-    PacketList::iterator i = m_sentList.begin();
+    auto i = m_sentList.begin();
     while (m_size > 0 && offset > 0)
     {
         if (i == m_sentList.end())
@@ -790,7 +788,7 @@
 
     for (auto option_it = list.begin(); option_it != list.end(); ++option_it)
     {
-        PacketList::iterator item_it = m_sentList.begin();
+        auto item_it = m_sentList.begin();
         SequenceNumber32 beginOfCurrentPacket = m_firstByteSeq;
 
         if (m_firstByteSeq + m_sentSize < (*option_it).first)
@@ -929,7 +927,6 @@
     NS_LOG_FUNCTION(this << seq);
 
     SequenceNumber32 beginOfCurrentPacket = m_firstByteSeq;
-    PacketList::const_iterator it;
 
     if (seq >= m_highestSack.second)
     {
@@ -938,7 +935,7 @@
 
     // In theory, using a map and hints when inserting elements can improve
     // performance
-    for (it = m_sentList.begin(); it != m_sentList.end(); ++it)
+    for (auto it = m_sentList.begin(); it != m_sentList.end(); ++it)
     {
         // Search for the right iterator before calling IsLost()
         if (beginOfCurrentPacket >= seq)
@@ -980,13 +977,12 @@
      *
      *     (1.c) IsLost (S2) returns true.
      */
-    PacketList::const_iterator it;
     TcpTxItem* item;
     SequenceNumber32 seqPerRule3;
     bool isSeqPerRule3Valid = false;
     SequenceNumber32 beginOfCurrentPkt = m_firstByteSeq;
 
-    for (it = m_sentList.begin(); it != m_sentList.end(); ++it)
+    for (auto it = m_sentList.begin(); it != m_sentList.end(); ++it)
     {
         item = *it;
 
@@ -1092,7 +1088,6 @@
 uint32_t
 TcpTxBuffer::BytesInFlightRFC() const
 {
-    PacketList::const_iterator it;
     TcpTxItem* item;
     uint32_t size = 0; // "pipe" in RFC
     SequenceNumber32 beginOfCurrentPkt = m_firstByteSeq;
@@ -1104,7 +1099,7 @@
     // After initializing pipe to zero, the following steps are taken for each
     // octet 'S1' in the sequence space between HighACK and HighData that has not
     // been SACKed:
-    for (it = m_sentList.begin(); it != m_sentList.end(); ++it)
+    for (auto it = m_sentList.begin(); it != m_sentList.end(); ++it)
     {
         item = *it;
         totalSize += item->m_packet->GetSize();
@@ -1472,14 +1467,13 @@
 std::ostream&
 operator<<(std::ostream& os, const TcpTxBuffer& tcpTxBuf)
 {
-    TcpTxBuffer::PacketList::const_iterator it;
     std::stringstream ss;
     SequenceNumber32 beginOfCurrentPacket = tcpTxBuf.m_firstByteSeq;
     uint32_t sentSize = 0;
     uint32_t appSize = 0;
 
     Ptr<const Packet> p;
-    for (it = tcpTxBuf.m_sentList.begin(); it != tcpTxBuf.m_sentList.end(); ++it)
+    for (auto it = tcpTxBuf.m_sentList.begin(); it != tcpTxBuf.m_sentList.end(); ++it)
     {
         p = (*it)->GetPacket();
         ss << "{";
@@ -1489,7 +1483,7 @@
         beginOfCurrentPacket += p->GetSize();
     }
 
-    for (it = tcpTxBuf.m_appList.begin(); it != tcpTxBuf.m_appList.end(); ++it)
+    for (auto it = tcpTxBuf.m_appList.begin(); it != tcpTxBuf.m_appList.end(); ++it)
     {
         appSize += (*it)->GetPacket()->GetSize();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-tx-buffer.h ns-3.40/src/internet/model/tcp-tx-buffer.h
--- ns-3.39/src/internet/model/tcp-tx-buffer.h	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/tcp-tx-buffer.h	2023-09-27 13:30:37.662839200 -0700
@@ -21,10 +21,11 @@
 #ifndef TCP_TX_BUFFER_H
 #define TCP_TX_BUFFER_H
 
+#include "tcp-option-sack.h"
+#include "tcp-tx-item.h"
+
 #include "ns3/object.h"
 #include "ns3/sequence-number.h"
-#include "ns3/tcp-option-sack.h"
-#include "ns3/tcp-tx-item.h"
 #include "ns3/traced-value.h"
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-westwood-plus.h ns-3.40/src/internet/model/tcp-westwood-plus.h
--- ns-3.39/src/internet/model/tcp-westwood-plus.h	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/tcp-westwood-plus.h	2023-09-27 13:30:37.666839100 -0700
@@ -33,10 +33,10 @@
 #define TCP_WESTWOOD_H
 
 #include "tcp-congestion-ops.h"
+#include "tcp-recovery-ops.h"
 
 #include "ns3/data-rate.h"
 #include "ns3/event-id.h"
-#include "ns3/tcp-recovery-ops.h"
 #include "ns3/traced-value.h"
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-yeah.cc ns-3.40/src/internet/model/tcp-yeah.cc
--- ns-3.39/src/internet/model/tcp-yeah.cc	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/tcp-yeah.cc	2023-09-27 13:30:37.666839100 -0700
@@ -249,7 +249,7 @@
 
             // queue = rttQueue * bw = rttQueue * (cwnd/RTTmin)
             double bw = segCwnd / m_minRtt.GetSeconds();
-            uint32_t queue = static_cast<uint32_t>(bw * rttQueue.GetSeconds());
+            auto queue = static_cast<uint32_t>(bw * rttQueue.GetSeconds());
             NS_LOG_DEBUG("Queue backlog = " << queue << " given by cwnd = " << segCwnd
                                             << ", minRtt = " << m_minRtt.GetMilliSeconds()
                                             << " ms, baseRtt = " << m_baseRtt.GetMilliSeconds()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/tcp-yeah.h ns-3.40/src/internet/model/tcp-yeah.h
--- ns-3.39/src/internet/model/tcp-yeah.h	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/tcp-yeah.h	2023-09-27 13:30:37.666839100 -0700
@@ -26,8 +26,8 @@
 #ifndef TCPYEAH_H
 #define TCPYEAH_H
 
-#include "ns3/tcp-recovery-ops.h"
-#include "ns3/tcp-scalable.h"
+#include "tcp-recovery-ops.h"
+#include "tcp-scalable.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/udp-header.cc ns-3.40/src/internet/model/udp-header.cc
--- ns-3.39/src/internet/model/udp-header.cc	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/udp-header.cc	2023-09-27 13:30:37.666839100 -0700
@@ -26,27 +26,6 @@
 
 NS_OBJECT_ENSURE_REGISTERED(UdpHeader);
 
-/* The magic values below are used only for debugging.
- * They can be used to easily detect memory corruption
- * problems so you can see the patterns in memory.
- */
-UdpHeader::UdpHeader()
-    : m_sourcePort(0xfffd),
-      m_destinationPort(0xfffd),
-      m_payloadSize(0),
-      m_checksum(0),
-      m_calcChecksum(false),
-      m_goodChecksum(true)
-{
-}
-
-UdpHeader::~UdpHeader()
-{
-    m_sourcePort = 0xfffe;
-    m_destinationPort = 0xfffe;
-    m_payloadSize = 0xfffe;
-}
-
 void
 UdpHeader::EnableChecksums()
 {
@@ -150,7 +129,7 @@
 void
 UdpHeader::ForcePayloadSize(uint16_t payloadSize)
 {
-    m_payloadSize = payloadSize;
+    m_forcedPayloadSize = payloadSize;
 }
 
 TypeId
@@ -189,13 +168,13 @@
 
     i.WriteHtonU16(m_sourcePort);
     i.WriteHtonU16(m_destinationPort);
-    if (m_payloadSize == 0)
+    if (m_forcedPayloadSize == 0)
     {
         i.WriteHtonU16(start.GetSize());
     }
     else
     {
-        i.WriteHtonU16(m_payloadSize);
+        i.WriteHtonU16(m_forcedPayloadSize);
     }
 
     if (m_checksum == 0)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/udp-header.h ns-3.40/src/internet/model/udp-header.h
--- ns-3.39/src/internet/model/udp-header.h	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/udp-header.h	2023-09-27 13:30:37.666839100 -0700
@@ -41,14 +41,6 @@
 {
   public:
     /**
-     * \brief Constructor
-     *
-     * Creates a null header
-     */
-    UdpHeader();
-    ~UdpHeader() override;
-
-    /**
      * \brief Enable checksum calculation for UDP
      */
     void EnableChecksums();
@@ -167,16 +159,21 @@
      * \returns the checksum
      */
     uint16_t CalculateHeaderChecksum(uint16_t size) const;
-    uint16_t m_sourcePort;      //!< Source port
-    uint16_t m_destinationPort; //!< Destination port
-    uint16_t m_payloadSize;     //!< Payload size
-
-    Address m_source;      //!< Source IP address
-    Address m_destination; //!< Destination IP address
-    uint8_t m_protocol;    //!< Protocol number
-    uint16_t m_checksum;   //!< Forced Checksum value
-    bool m_calcChecksum;   //!< Flag to calculate checksum
-    bool m_goodChecksum;   //!< Flag to indicate that checksum is correct
+
+    // The magic values below are used only for debugging.
+    // They can be used to easily detect memory corruption
+    // problems so you can see the patterns in memory.
+    uint16_t m_sourcePort{0xfffd};      //!< Source port
+    uint16_t m_destinationPort{0xfffd}; //!< Destination port
+    uint16_t m_payloadSize{0};          //!< Payload size
+    uint16_t m_forcedPayloadSize{0};    //!< Payload size (forced)
+
+    Address m_source;           //!< Source IP address
+    Address m_destination;      //!< Destination IP address
+    uint8_t m_protocol{17};     //!< Protocol number
+    uint16_t m_checksum{0};     //!< Forced Checksum value
+    bool m_calcChecksum{false}; //!< Flag to calculate checksum
+    bool m_goodChecksum{true};  //!< Flag to indicate that checksum is correct
 };
 
 } // namespace ns3
